/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahlrechtspruefung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahlrechtspruefung.entity.Wahlrechtspruefung;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractWahlrechtspruefungSearch {

  @Inject
  protected transient WahlrechtspruefungExtendedDAO dao;

  public AbstractWahlrechtspruefungSearch() {
    super();
  }

  public List<Wahlrechtspruefung> getSearchResult(WahlrechtspruefungSearchParameters searchParameters, EagerLoadingCollector<Wahlrechtspruefung> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Wahlrechtspruefung> querySearchResult(WahlrechtspruefungSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
